assert( Necronomicon, "Necronomicon not found!")

-- Demon Skin
-- Demon Armor
-- Fel Armor
-- Pick and Choose between Demon or Fel. (LeftClick, RightClick)

----------------------------------
--        Are you local?        --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("Necronomicon")
local BS = AceLibrary("Babble-Spell-2.2")
local hasfelarmor = nil
local hasdemonarmor = nil
local hasaura = nil

local felarmoricon = "Interface\\Icons\\Spell_Shadow_FelArmour"
local demonarmoricon = "Interface\\Icons\\Spell_Shadow_RagingScream" 

----------------------------------
--      Module Declaration      --
----------------------------------

NecronomiconArmor = Necronomicon:NewModule("Armor")
NecronomiconArmor.name = "Armor"

NecronomiconArmor.revision = tonumber(string.sub("$Revision: 26617 $", 12, -3))

NecronomiconArmor.defaults = {
	posx = 296,
	posy = 200,
}

----------------------------------
--     Module Intialization     --
----------------------------------

function NecronomiconArmor:OnRegister()
	self:RegisterSpell("Demon Skin")
	self:RegisterSpell("Demon Armor")
	self:RegisterSpell("Fel Armor")
end

function NecronomiconArmor:OnEnable()
	self:SetupButton()
	self:RegisterEvent("UNIT_AURA")
	self:RegisterEvent("Necronomicon_ClearSpells")
	self:RegisterEvent("Necronomicon_HasSpell")
	self:ScanAuras()
end

----------------------------------
--        Event Handlers        --
----------------------------------

function NecronomiconArmor:Necronomicon_ClearSpells()
	hasfelarmor = nil
	hasdemonarmor = nil
	self.button:SetAttribute("type1", "")
	self.button:SetAttribute("spell1", "")
	self.button:SetAttribute("type2", "")
	self.button:SetAttribute("spell2", "")

	self.button:Hide()	
end

function NecronomiconArmor:Necronomicon_HasSpell( enspell, spell, subspell, spellid )
	if not enspell then return end
	if ( enspell == "Demon Skin" or enspell == "Demon Armor" ) and not hasdemonarmor then
		if hasfelarmor then
			self.button:SetAttribute("type2", "spell")
			self.button:SetAttribute("spell2", ( GetSpellName( spellid, BOOKTYPE_SPELL) ) )
		else
			self.button:SetAttribute("type1", "spell")
			self.button:SetAttribute("spell1", ( GetSpellName( spellid, BOOKTYPE_SPELL) ) )
		end
		self.button.background:SetTexture( demonarmoricon )
		self:UpdateSaturation()
		self.button:Show()
		hasdemonarmor = true
	elseif enspell == "Fel Armor" then
		if hasdemonarmor then
			local oldid = self.button:GetAttribute("spell1")
			if oldid then
				self.button:SetAttribute("type2", "spell")
				self.button:SetAttribute("spell2", oldid)
			end			
		end
		self.button:SetAttribute("type1", "spell")
		self.button:SetAttribute("spell1", ( GetSpellName( spellid, BOOKTYPE_SPELL) ) )
		
		self.button.background:SetTexture( felarmoricon )
		self:UpdateSaturation()
		self.button:Show()
		hasfelarmor = true
	end

end

function NecronomiconArmor:UNIT_AURA( unit )
	if not unit or unit ~= "player" then return end
	self:ScheduleEvent("NecronomiconArmor", self.ScanAuras, 0.5, self )
end

function NecronomiconArmor:ScanAuras()
	local pindex, name, rank

	hasaura = nil

	for i = 1, 32 do
		pindex = GetPlayerBuff(i, "HELPFUL")
		name, rank = GetPlayerBuffName(pindex)
		if name and ( name == BS["Demon Armor"] or name == BS["Demon Skin"] or name == BS["Fel Armor"] ) then
			hasaura = true
		end
	end
	self:UpdateSaturation()
end

----------------------------------
--         GUI Functions        --
----------------------------------

function NecronomiconArmor:UpdateSaturation()
	if hasaura then
		self.button.background:SetDesaturated( false )
	else
		self.button.background:SetDesaturated( true )
	end
end

function NecronomiconArmor:SetupButton()
	self:CreateButton()
	self.button.background:SetTexture( demonarmoricon )
	self:UpdateSaturation()
end
